ifndef     _DD_UTIL
_DD_UTIL   equ 1

.data?

DDFont LOGFONT <?>
DD_font        dd ?
IP_Bitmap      dd ?
IP_Data        dd ?

.code

Load_File proc Filename:DWORD
   LOCAL   hFile,dwLength,dwReadbytes,pPTR:DWORD

   invoke  CreateFile,Filename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
   inc     eax
   jz      Error
   dec     eax
   mov     hFile,eax
   invoke  GetFileSize,hFile,NULL
   inc     eax
   jz      Error
   dec     eax
   mov     dwLength,eax

   ALLOC_MEM   pPTR,dwLength
   test    eax,eax
   jz      Error

   invoke  ReadFile,hFile,pPTR,dwLength,addr dwReadbytes,NULL
   test    eax,eax
   jz      Error
   invoke  CloseHandle,hFile
   mov     eax,pPTR
   mov     ecx,dwLength
Error:
   ret
Load_File endp

Save_File proc Filename:DWORD,File_ptr:DWORD,dwLength:DWORD
   LOCAL   hFile,dwWritebytes:DWORD
   invoke  CreateFile,Filename,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
   inc     eax
   jz      Error
   dec     eax
   mov     hFile,eax

   invoke  WriteFile,hFile,File_ptr,dwLength,addr dwWritebytes,NULL
   test    eax,eax
   jz      Error
   invoke  CloseHandle,hFile
   mov     eax,dwWritebytes
Error:
   ret
Save_File endp

Create_Surface proc Surface_Width:DWORD,Surface_Height:DWORD,Surface:DWORD
   LOCAL pDDS:LPDIRECTDRAWSURFACE7

   mov         eax,Surface   ; get the buffer adres
   mov         eax,[eax]
   mov         pDDS,eax ; save adres
   SAFE_RELEASE pDDS

   invoke  RtlZeroMemory,addr ddsd,sizeof DDSURFACEDESC2
   mov     ddsd.dwSize,sizeof DDSURFACEDESC2
   mov     ddsd.dwFlags,DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT
   mov     ddsd.ddsCaps.dwCaps,DDSCAPS_OFFSCREENPLAIN

   m2m     ddsd.dwWidth,Surface_Width
   m2m     ddsd.dwHeight,Surface_Height

   coinvoke g_pDD,IDirectDraw7,CreateSurface,addr ddsd,addr pDDS, NULL
   .if eax != DD_OK
       mov    pDDS,NULL ; save adres
       return E_FAIL
   .endif

   mov         eax,Surface
   mov         ecx,pDDS
   mov         [eax],ecx       ; save buffer adres

   return  S_OK
Create_Surface endp


Init_DDFont proc uses ecx edx font_name:DWORD,font_height:DWORD
 local hdcTemp:HDC

   coinvoke g_pDDSBack,IDirectDrawSurface7,GetDC,addr hdcTemp
   .if eax == DD_OK

       .if DD_font != 0
           invoke  DeleteObject,DD_font
       .endif

       invoke  GetDeviceCaps,hdcTemp,LOGPIXELSY
       mul     font_height
       mov     ecx,72
       xor     edx,edx
       div     ecx
       neg     eax
       mov     DDFont.lfHeight,eax
       mov     DDFont.lfWidth,0
       mov     DDFont.lfEscapement,0
       mov     DDFont.lfOrientation,0
       mov     DDFont.lfWeight,FW_NORMAL
       mov     DDFont.lfItalic,FALSE
       mov     DDFont.lfUnderline,FALSE
       mov     DDFont.lfStrikeOut,FALSE
       mov     DDFont.lfCharSet,DEFAULT_CHARSET
       mov     DDFont.lfOutPrecision,OUT_DEFAULT_PRECIS
       mov     DDFont.lfClipPrecision,CLIP_DEFAULT_PRECIS
       mov     DDFont.lfQuality,DEFAULT_QUALITY
       invoke  lstrcpy,addr DDFont.lfFaceName,font_name
       invoke  CreateFontIndirect,addr DDFont
       mov     DD_font,eax
       coinvoke g_pDDSBack,IDirectDrawSurface7,ReleaseDC,hdcTemp
   .endif
   ret
Init_DDFont endp

;Save_picture proc ddsurf:DWORD,String_ptr:DWORD
; local hdcTemp:HDC
;   coinvoke ddsurf,IDirectDrawSurface7,GetDC,addr hdcTemp
;   .if eax == DD_OK
;
;
;       coinvoke ddsurf,IDirectDrawSurface7,ReleaseDC,hdcTemp
;   .endif
;	ret
;Save_picture endp

Print_Text proc tX:DWORD,tY:DWORD,color:DWORD,String_ptr:DWORD
 local hdcTemp:HDC
   coinvoke g_pDDSBack,IDirectDrawSurface7,GetDC,addr hdcTemp
   .if eax == DD_OK

       invoke  SelectObject,hdcTemp,DD_font

       invoke  SetBkMode,hdcTemp,TRANSPARENT
       invoke  SetTextColor,hdcTemp,color
       invoke  lstrlen,String_ptr
       invoke  TextOut,hdcTemp,tX,tY,String_ptr,eax

       coinvoke g_pDDSBack,IDirectDrawSurface7,ReleaseDC,hdcTemp
   .endif
   ret
Print_Text endp

Set_TransparantColor proc ddsurf:DWORD,color:DWORD
 local hdcTemp:HDC
 local colorTemp:COLORREF

   coinvoke ddsurf,IDirectDrawSurface7,GetDC,addr hdcTemp
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("GetDC FAILED"),offset szDXInfo,MB_OK
       return E_FAIL
   .endif

   invoke  GetPixel,hdcTemp,0,0
   mov     colorTemp,eax
   invoke  SetPixel,hdcTemp,0,0,color
   coinvoke ddsurf,IDirectDrawSurface7,ReleaseDC,hdcTemp

   mov     ddsd.dwSize,sizeof DDSURFACEDESC2
   coinvoke ddsurf,IDirectDrawSurface7,Lock,NULL,addr ddsd,0,NULL
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("Lock Surface FAILED"),offset szDXInfo,MB_OK
       return E_FAIL
   .endif

       mov     ecx,ddsd.ddpfPixelFormat.dwRGBBitCount
       .if ecx < 32
           mov     edx,1
           shl     edx,cl
           dec     edx
           mov     eax,ddsd.lpSurface
           mov     eax,[eax]
           and     eax,edx
           mov     color,eax
       .endif

   coinvoke ddsurf,IDirectDrawSurface7,Unlock,NULL
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("Unlock Surface FAILED"),offset szDXInfo,MB_OK
      return E_FAIL
   .endif

   coinvoke ddsurf,IDirectDrawSurface7,GetDC,addr hdcTemp
   .if eax == DD_OK
       invoke  SetPixel,hdcTemp,0,0,colorTemp
       coinvoke ddsurf,IDirectDrawSurface7,ReleaseDC,hdcTemp
   .endif
 
   m2m     colorkey.dwColorSpaceLowValue,color
   m2m     colorkey.dwColorSpaceHighValue,color

   coinvoke ddsurf,IDirectDrawSurface7,SetColorKey,DDCKEY_SRCBLT,addr colorkey
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("SetColorKey FAILED"),offset szDXInfo,MB_OK
       return E_FAIL
   .endif

  return  S_OK
Set_TransparantColor endp


Copy_Bitmap proc uses esi PictureInfo:DWORD
 local hdcTemp,hdcPic:HDC
   invoke  RtlZeroMemory,addr ddsd,sizeof DDSURFACEDESC2
   mov     ddsd.dwSize,sizeof DDSURFACEDESC2
   mov     ddsd.dwFlags,DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT
   mov     ddsd.ddsCaps.dwCaps,DDSCAPS_OFFSCREENPLAIN

   mov     esi,PictureInfo
   m2m     ddsd.dwWidth,[esi].DD_PICTURE.dwWidth
   m2m     ddsd.dwHeight,[esi].DD_PICTURE.dwHeight

   coinvoke g_pDD,IDirectDraw7,CreateSurface,addr ddsd,addr [esi].DD_PICTURE.dwSurface, NULL
   .if eax != DD_OK
       invoke  DeleteObject,IP_Bitmap
       return E_FAIL
   .endif

   coinvoke [esi].DD_PICTURE.dwSurface,IDirectDrawSurface7,GetDC,addr hdcTemp
   .if eax == DD_OK
       invoke  CreateCompatibleDC,hdcTemp
       mov     hdcPic,eax

       invoke  SelectObject,hdcPic,IP_Bitmap

       invoke  BitBlt,hdcTemp,0,0,[esi].DD_PICTURE.dwWidth,[esi].DD_PICTURE.dwHeight,hdcPic,0,0,SRCCOPY

       coinvoke [esi].DD_PICTURE.dwSurface,IDirectDrawSurface7,ReleaseDC,hdcTemp
   .endif
   invoke  DeleteObject,IP_Bitmap
   invoke  DeleteDC,hdcPic
   return  S_OK
Copy_Bitmap endp


Load_Bitmap proc  uses esi PictureName:DWORD,PictureInfo:DWORD
 local PictureBuffer:dword
 local rsrcData:dword
 local fSize:dword
 local pStream:dword
 local pPicture:LPIPICTURE
 local hdcTemp:HDC
 local binfo:BITMAPINFO
 local IPicWidth:dword
 local IPicHeight:dword
                  
   invoke  FindResource,NULL,PictureName,TEXT_("PICTURE")
   test    eax,eax
   jz      Find_Picture ; No picture in the resource, so look somewhere else
   push    eax

   invoke  SizeofResource,NULL,eax
   mov     fSize,eax

   ALLOC_MEM   PictureBuffer,eax
   test    eax,eax
   jz      Err_PIC_Load

   pop     eax
   invoke  LoadResource,NULL,eax
   invoke  LockResource,eax
   mov     rsrcData,eax

   mov     esi,rsrcData
   mov     edi,PictureBuffer
   mov     ecx,fSize
   cld
   rep     movsb

   invoke  FreeResource,rsrcData
   jmp     Loading_pic

Find_Picture:
   invoke  Load_File,PictureName
   test    eax,eax
   jz      Err_PIC_Load
   mov     PictureBuffer,eax

Loading_pic:
   invoke  CreateStreamOnHGlobal,PictureBuffer,TRUE,addr pStream
   cmp     eax,S_OK
   jne     Err_PIC_CStream

   invoke  OleLoadPicture,pStream,NULL,TRUE,GUID_ADDR(IID_IPicture),addr pPicture
   cmp     eax,S_OK
   jne Err_PIC_Stream

   invoke  GetDC,NULL
   push    eax
   invoke  CreateCompatibleDC,eax
   mov     hdcTemp,eax
   pop     eax
   invoke  DeleteDC,eax

   mov     esi,PictureInfo
   SAFE_RELEASE [esi].DD_PICTURE.dwSurface

           ; Get IPicture width and height
   coinvoke pPicture,IPicture,get_Width,addr IPicWidth
   coinvoke pPicture,IPicture,get_Height,addr IPicHeight

           ; Convert to pixels
   invoke  GetDeviceCaps,hdcTemp,LOGPIXELSX
   invoke  MulDiv,IPicWidth,eax,HIMETRIC_INCH
   mov     [esi].DD_PICTURE.dwWidth,eax
   invoke  GetDeviceCaps,hdcTemp,LOGPIXELSY
   invoke  MulDiv,IPicHeight,eax,HIMETRIC_INCH
   mov     [esi].DD_PICTURE.dwHeight,eax

   invoke  RtlZeroMemory,addr binfo.bmiHeader,sizeof BITMAPINFOHEADER

   mov     binfo.bmiHeader.biSize,sizeof BITMAPINFOHEADER
   mov     binfo.bmiHeader.biBitCount,32    ; we want only 32 bit
   mov     eax,[esi].DD_PICTURE.dwWidth
   mov     binfo.bmiHeader.biWidth,eax
   mov     eax,[esi].DD_PICTURE.dwHeight
   mov     binfo.bmiHeader.biHeight,eax
   mov     binfo.bmiHeader.biCompression,BI_RGB
   mov     binfo.bmiHeader.biPlanes,1

   ; we do a "CreateDIBSection" so we have acces to the pixel-data and change whatever we want......
   invoke  CreateDIBSection,hdcTemp,addr binfo,DIB_RGB_COLORS,addr IP_Data,NULL, 0
   test    eax,eax
   jz      Err_PIC_DIB
   mov     IP_Bitmap,eax

   invoke  SelectObject,hdcTemp,IP_Bitmap
   test    eax,eax
   jz      Err_PIC_Render

   mov     eax,IPicHeight
   neg     eax
   coinvoke pPicture,IPicture,Render,hdcTemp,0,0,[esi].DD_PICTURE.dwWidth,[esi].DD_PICTURE.dwHeight,0,IPicHeight,IPicWidth,eax,0
   cmp     eax,S_OK
   jne     Err_PIC_Render

   invoke  DeleteDC,hdcTemp
   SAFE_RELEASE pPicture
   SAFE_RELEASE pStream
   return  S_OK
Err_PIC_Render:
   invoke  DeleteObject,IP_Bitmap
Err_PIC_DIB:
   invoke  DeleteDC,hdcTemp
   SAFE_RELEASE pPicture
Err_PIC_Stream:
   SAFE_RELEASE pStream
   return  E_FAIL
Err_PIC_CStream:
   SAFE_DELETE PictureBuffer
Err_PIC_Load:
   return  E_FAIL
Load_Bitmap endp

Load_Picture proc PictureName:DWORD,PictureInfo:DWORD
   invoke  Load_Bitmap,PictureName,PictureInfo
   .if eax != S_OK
       invoke MessageBox,NULL,TEXT_("Load_Bitmap FAILED"),offset szDXInfo,MB_OK
       return E_FAIL
   .endif

   invoke  Copy_Bitmap,PictureInfo
   .if eax != S_OK
       invoke MessageBox,NULL,TEXT_("Create Picture Surface FAILED"),offset szDXInfo,MB_OK
       return E_FAIL
   .endif
   return DD_OK
Load_Picture endp

endif